<?php

namespace clonixdev\aemetsii;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'SuministroInformacion' => '\\clonixdev\\aemetsii\\StructType\\SuministroInformacion',
            'SuministroInformacionBaja' => '\\clonixdev\\aemetsii\\StructType\\SuministroInformacionBaja',
            'SuministroInformacionCobrosPagos' => '\\clonixdev\\aemetsii\\StructType\\SuministroInformacionCobrosPagos',
            'SuministroInformacionInmuebles' => '\\clonixdev\\aemetsii\\StructType\\SuministroInformacionInmuebles',
            'ConsultaInformacion' => '\\clonixdev\\aemetsii\\StructType\\ConsultaInformacion',
            'ConsultaInformacionCliente' => '\\clonixdev\\aemetsii\\StructType\\ConsultaInformacionCliente',
            'ConsultaInformacionProveedor' => '\\clonixdev\\aemetsii\\StructType\\ConsultaInformacionProveedor',
            'CabeceraSii' => '\\clonixdev\\aemetsii\\StructType\\CabeceraSii',
            'CabeceraSiiBaja' => '\\clonixdev\\aemetsii\\StructType\\CabeceraSiiBaja',
            'CabeceraSiiCobrosPagos' => '\\clonixdev\\aemetsii\\StructType\\CabeceraSiiCobrosPagos',
            'DatosPresentacionType' => '\\clonixdev\\aemetsii\\StructType\\DatosPresentacionType',
            'DatosPresentacion2Type' => '\\clonixdev\\aemetsii\\StructType\\DatosPresentacion2Type',
            'CabeceraConsultaSii' => '\\clonixdev\\aemetsii\\StructType\\CabeceraConsultaSii',
            'CabeceraConsultaSiiCliente' => '\\clonixdev\\aemetsii\\StructType\\CabeceraConsultaSiiCliente',
            'CabeceraConsultaSiiProveedor' => '\\clonixdev\\aemetsii\\StructType\\CabeceraConsultaSiiProveedor',
            'RegistroSii' => '\\clonixdev\\aemetsii\\StructType\\RegistroSii',
            'PeriodoLiquidacion' => '\\clonixdev\\aemetsii\\StructType\\PeriodoLiquidacion',
            'RegistroSiiImputacion' => '\\clonixdev\\aemetsii\\StructType\\RegistroSiiImputacion',
            'PeriodoImputacion' => '\\clonixdev\\aemetsii\\StructType\\PeriodoImputacion',
            'OperacionIntracomunitariaType' => '\\clonixdev\\aemetsii\\StructType\\OperacionIntracomunitariaType',
            'BienDeInversionType' => '\\clonixdev\\aemetsii\\StructType\\BienDeInversionType',
            'IDFacturaComunitariaType' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaComunitariaType',
            'IDEmisorFactura' => '\\clonixdev\\aemetsii\\StructType\\IDEmisorFactura',
            'IDFacturaImputacionType' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaImputacionType',
            'ClavePaginacionProveedorType' => '\\clonixdev\\aemetsii\\StructType\\ClavePaginacionProveedorType',
            'ClavePaginacionClienteType' => '\\clonixdev\\aemetsii\\StructType\\ClavePaginacionClienteType',
            'ClavePaginacionBienType' => '\\clonixdev\\aemetsii\\StructType\\ClavePaginacionBienType',
            'IDFacturaConsulta1Type' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaConsulta1Type',
            'IDFacturaExpedidaBCType' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaExpedidaBCType',
            'IDFacturaConsulta2Type' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaConsulta2Type',
            'IDFacturaExpedidaType' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaExpedidaType',
            'IDFacturaRecibidaType' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaRecibidaType',
            'IDFacturaRecibidaNombreType' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaRecibidaNombreType',
            'IDFacturaRecibidaNombreBCType' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaRecibidaNombreBCType',
            'IDFacturaARType' => '\\clonixdev\\aemetsii\\StructType\\IDFacturaARType',
            'FacturaType' => '\\clonixdev\\aemetsii\\StructType\\FacturaType',
            'FacturasAgrupadas' => '\\clonixdev\\aemetsii\\StructType\\FacturasAgrupadas',
            'FacturasRectificadas' => '\\clonixdev\\aemetsii\\StructType\\FacturasRectificadas',
            'FacturaExpedidaType' => '\\clonixdev\\aemetsii\\StructType\\FacturaExpedidaType',
            'DatosInmueble' => '\\clonixdev\\aemetsii\\StructType\\DatosInmueble',
            'TipoDesglose' => '\\clonixdev\\aemetsii\\StructType\\TipoDesglose',
            'DesgloseFacturaRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\DesgloseFacturaRecibidasType',
            'InversionSujetoPasivo' => '\\clonixdev\\aemetsii\\StructType\\InversionSujetoPasivo',
            'DesgloseIVA' => '\\clonixdev\\aemetsii\\StructType\\DesgloseIVA',
            'FacturaRecibidaType' => '\\clonixdev\\aemetsii\\StructType\\FacturaRecibidaType',
            'CobrosType' => '\\clonixdev\\aemetsii\\StructType\\CobrosType',
            'PagosType' => '\\clonixdev\\aemetsii\\StructType\\PagosType',
            'DetalleIVAEmitidaType' => '\\clonixdev\\aemetsii\\StructType\\DetalleIVAEmitidaType',
            'DetalleExentaType' => '\\clonixdev\\aemetsii\\StructType\\DetalleExentaType',
            'DetalleIVARecibida2Type' => '\\clonixdev\\aemetsii\\StructType\\DetalleIVARecibida2Type',
            'DetalleIVAEmitidaPrestacionType' => '\\clonixdev\\aemetsii\\StructType\\DetalleIVAEmitidaPrestacionType',
            'DetalleIVARecibidaType' => '\\clonixdev\\aemetsii\\StructType\\DetalleIVARecibidaType',
            'DesgloseRectificacionType' => '\\clonixdev\\aemetsii\\StructType\\DesgloseRectificacionType',
            'AduanasType' => '\\clonixdev\\aemetsii\\StructType\\AduanasType',
            'DatosInmuebleType' => '\\clonixdev\\aemetsii\\StructType\\DatosInmuebleType',
            'DatosPagoCobroType' => '\\clonixdev\\aemetsii\\StructType\\DatosPagoCobroType',
            'PersonaFisicaJuridicaESType' => '\\clonixdev\\aemetsii\\StructType\\PersonaFisicaJuridicaESType',
            'PersonaFisicaJuridicaUnicaESType' => '\\clonixdev\\aemetsii\\StructType\\PersonaFisicaJuridicaUnicaESType',
            'PersonaFisicaJuridicaType' => '\\clonixdev\\aemetsii\\StructType\\PersonaFisicaJuridicaType',
            'ContraparteConsultaType' => '\\clonixdev\\aemetsii\\StructType\\ContraparteConsultaType',
            'IDOtroType' => '\\clonixdev\\aemetsii\\StructType\\IDOtroType',
            'TipoConDesgloseType' => '\\clonixdev\\aemetsii\\StructType\\TipoConDesgloseType',
            'TipoSinDesgloseType' => '\\clonixdev\\aemetsii\\StructType\\TipoSinDesgloseType',
            'TipoSinDesglosePrestacionType' => '\\clonixdev\\aemetsii\\StructType\\TipoSinDesglosePrestacionType',
            'NoSujetaType' => '\\clonixdev\\aemetsii\\StructType\\NoSujetaType',
            'SujetaType' => '\\clonixdev\\aemetsii\\StructType\\SujetaType',
            'Exenta' => '\\clonixdev\\aemetsii\\StructType\\Exenta',
            'NoExenta' => '\\clonixdev\\aemetsii\\StructType\\NoExenta',
            'SujetaPrestacionType' => '\\clonixdev\\aemetsii\\StructType\\SujetaPrestacionType',
            'IdRegistroExpInicialType' => '\\clonixdev\\aemetsii\\StructType\\IdRegistroExpInicialType',
            'DepositoType' => '\\clonixdev\\aemetsii\\StructType\\DepositoType',
            'VentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\VentaBienesConsignaType',
            'InfoExpedicionRecepcionType' => '\\clonixdev\\aemetsii\\StructType\\InfoExpedicionRecepcionType',
            'IdRegistroDeclaradoType' => '\\clonixdev\\aemetsii\\StructType\\IdRegistroDeclaradoType',
            'DestinoFinalExpedRecepType' => '\\clonixdev\\aemetsii\\StructType\\DestinoFinalExpedRecepType',
            'RangoFechaPresentacionType' => '\\clonixdev\\aemetsii\\StructType\\RangoFechaPresentacionType',
            'RangoFechaType' => '\\clonixdev\\aemetsii\\StructType\\RangoFechaType',
            'RegistroDuplicadoType' => '\\clonixdev\\aemetsii\\StructType\\RegistroDuplicadoType',
            'SuministroLRFacturasEmitidas' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRFacturasEmitidas',
            'LRfacturasEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\LRfacturasEmitidasType',
            'BajaLRFacturasEmitidas' => '\\clonixdev\\aemetsii\\StructType\\BajaLRFacturasEmitidas',
            'LRBajaExpedidasType' => '\\clonixdev\\aemetsii\\StructType\\LRBajaExpedidasType',
            'SuministroLRFacturasRecibidas' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRFacturasRecibidas',
            'LRFacturasRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\LRFacturasRecibidasType',
            'BajaLRFacturasRecibidas' => '\\clonixdev\\aemetsii\\StructType\\BajaLRFacturasRecibidas',
            'LRBajaRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\LRBajaRecibidasType',
            'SuministroLRBienesInversion' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRBienesInversion',
            'LRBienesInversionType' => '\\clonixdev\\aemetsii\\StructType\\LRBienesInversionType',
            'BajaLRBienesInversion' => '\\clonixdev\\aemetsii\\StructType\\BajaLRBienesInversion',
            'LRBajaBienesInversionType' => '\\clonixdev\\aemetsii\\StructType\\LRBajaBienesInversionType',
            'SuministroLRAgenciasViajes' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRAgenciasViajes',
            'LRAgenciasViajesType' => '\\clonixdev\\aemetsii\\StructType\\LRAgenciasViajesType',
            'BajaLRAgenciasViajes' => '\\clonixdev\\aemetsii\\StructType\\BajaLRAgenciasViajes',
            'LRBajaAgenciasViajesType' => '\\clonixdev\\aemetsii\\StructType\\LRBajaAgenciasViajesType',
            'SuministroLRCobrosMetalico' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRCobrosMetalico',
            'LRCobrosMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\LRCobrosMetalicoType',
            'BajaLRCobrosMetalico' => '\\clonixdev\\aemetsii\\StructType\\BajaLRCobrosMetalico',
            'LRBajaCobrosMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\LRBajaCobrosMetalicoType',
            'SuministroLROperacionesSeguros' => '\\clonixdev\\aemetsii\\StructType\\SuministroLROperacionesSeguros',
            'LROperacionesSegurosType' => '\\clonixdev\\aemetsii\\StructType\\LROperacionesSegurosType',
            'BajaLROperacionesSeguros' => '\\clonixdev\\aemetsii\\StructType\\BajaLROperacionesSeguros',
            'LRBajaRegistroLROperacionesSegurosType' => '\\clonixdev\\aemetsii\\StructType\\LRBajaRegistroLROperacionesSegurosType',
            'SuministroLRDetOperacionIntracomunitaria' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRDetOperacionIntracomunitaria',
            'LROperacionIntracomunitariaType' => '\\clonixdev\\aemetsii\\StructType\\LROperacionIntracomunitariaType',
            'BajaLRDetOperacionIntracomunitaria' => '\\clonixdev\\aemetsii\\StructType\\BajaLRDetOperacionIntracomunitaria',
            'LRBajaOperacionIntracomunitariaType' => '\\clonixdev\\aemetsii\\StructType\\LRBajaOperacionIntracomunitariaType',
            'SuministroLRCobrosEmitidas' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRCobrosEmitidas',
            'SuministroLRInmueblesAdicionales' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRInmueblesAdicionales',
            'LRCobrosEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\LRCobrosEmitidasType',
            'LRInmueblesType' => '\\clonixdev\\aemetsii\\StructType\\LRInmueblesType',
            'InmueblesAdicionalType' => '\\clonixdev\\aemetsii\\StructType\\InmueblesAdicionalType',
            'SuministroLRPagosRecibidas' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRPagosRecibidas',
            'LRPagosEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\LRPagosEmitidasType',
            'SuministroLRVentaBienesConsigna' => '\\clonixdev\\aemetsii\\StructType\\SuministroLRVentaBienesConsigna',
            'LRVentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\LRVentaBienesConsignaType',
            'BajaLRVentaBienesConsigna' => '\\clonixdev\\aemetsii\\StructType\\BajaLRVentaBienesConsigna',
            'LRBajaVentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\LRBajaVentaBienesConsignaType',
            'LRFiltroEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroEmitidasType',
            'LRFiltroFactInformadasClienteType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroFactInformadasClienteType',
            'LRFiltroFactInformadasAgrupadasClienteType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroFactInformadasAgrupadasClienteType',
            'LRFiltroFactInformadasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroFactInformadasProveedorType',
            'LRFiltroFactInformadasAgrupadasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroFactInformadasAgrupadasProveedorType',
            'LRFiltroRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroRecibidasType',
            'LRFiltroBienInversionType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroBienInversionType',
            'LRFiltroDetOperIntracomunitariasType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroDetOperIntracomunitariasType',
            'LRFiltroOperacionesSegurosType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroOperacionesSegurosType',
            'ClavePaginacion' => '\\clonixdev\\aemetsii\\StructType\\ClavePaginacion',
            'LRFiltroCobrosMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroCobrosMetalicoType',
            'LRFiltroAgenciasViajesType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroAgenciasViajesType',
            'LRFiltroCobrosType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroCobrosType',
            'LRFiltroInmueblesAdicionalesType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroInmueblesAdicionalesType',
            'LRFiltroPagosType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroPagosType',
            'LRFiltroVentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\LRFiltroVentaBienesConsignaType',
            'LRConsultaRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\LRConsultaRecibidasType',
            'LRConsultaEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\LRConsultaEmitidasType',
            'ConsultaLRFactInformadasClienteType' => '\\clonixdev\\aemetsii\\StructType\\ConsultaLRFactInformadasClienteType',
            'ConsultaLRFactInformadasAgrupadasClienteType' => '\\clonixdev\\aemetsii\\StructType\\ConsultaLRFactInformadasAgrupadasClienteType',
            'ConsultaLRFactInformadasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\ConsultaLRFactInformadasProveedorType',
            'ConsultaLRFactInformadasAgrupadasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\ConsultaLRFactInformadasAgrupadasProveedorType',
            'LRConsultaBienesInversionType' => '\\clonixdev\\aemetsii\\StructType\\LRConsultaBienesInversionType',
            'LRConsultaDetOperIntracomunitariasType' => '\\clonixdev\\aemetsii\\StructType\\LRConsultaDetOperIntracomunitariasType',
            'LRConsultaCobrosMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\LRConsultaCobrosMetalicoType',
            'LRConsultaAgenciasViajesType' => '\\clonixdev\\aemetsii\\StructType\\LRConsultaAgenciasViajesType',
            'LRConsultaLROperacionesSegurosType' => '\\clonixdev\\aemetsii\\StructType\\LRConsultaLROperacionesSegurosType',
            'ConsultaCobrosType' => '\\clonixdev\\aemetsii\\StructType\\ConsultaCobrosType',
            'ConsultaPagosType' => '\\clonixdev\\aemetsii\\StructType\\ConsultaPagosType',
            'ConsultaInmueblesAdicionalesType' => '\\clonixdev\\aemetsii\\StructType\\ConsultaInmueblesAdicionalesType',
            'LRConsultaVentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\LRConsultaVentaBienesConsignaType',
            'RespuestaConsultaLRFacturasEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFacturasEmitidasType',
            'RespuestaConsultaLRFacturasRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFacturasRecibidasType',
            'RespuestaConsultaLRFactInformadasClienteType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFactInformadasClienteType',
            'RespuestaConsultaLRFactInformadasAgrupadasClienteType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFactInformadasAgrupadasClienteType',
            'RespuestaConsultaLRFactInformadasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFactInformadasProveedorType',
            'RespuestaConsultaLRFactInformadasAgrupadasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFactInformadasAgrupadasProveedorType',
            'RespuestaConsultaLRBienesInversionType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRBienesInversionType',
            'RespuestaConsultaLRDetOperIntracomunitariasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRDetOperIntracomunitariasType',
            'RespuestaConsultaLRCobrosMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRCobrosMetalicoType',
            'RespuestaConsultaLRAgenciasViajesType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRAgenciasViajesType',
            'RespuestaConsultaLRVentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRVentaBienesConsignaType',
            'RespuestaConsultaLROperacionesSegurosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLROperacionesSegurosType',
            'RespuestaConsultaLRFacturasClienteType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFacturasClienteType',
            'RespuestaConsultaLRFacturasAgrupadasClienteType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFacturasAgrupadasClienteType',
            'RespuestaConsultaLRFacturasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFacturasProveedorType',
            'RespuestaConsultaLRFacturasAgrupadasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFacturasAgrupadasProveedorType',
            'RespuestaConsultaCobrosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaCobrosType',
            'RespuestaConsultaInmueblesAdicionalesType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaInmueblesAdicionalesType',
            'RespuestaConsultaPagosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaPagosType',
            'TitularPeriodoType' => '\\clonixdev\\aemetsii\\StructType\\TitularPeriodoType',
            'EstadoFacturaType' => '\\clonixdev\\aemetsii\\StructType\\EstadoFacturaType',
            'EstadoFacturaImputacionType' => '\\clonixdev\\aemetsii\\StructType\\EstadoFacturaImputacionType',
            'DatosDescuadreContraparteType' => '\\clonixdev\\aemetsii\\StructType\\DatosDescuadreContraparteType',
            'EstadoFactura2Type' => '\\clonixdev\\aemetsii\\StructType\\EstadoFactura2Type',
            'RegistroRespuestaConsultaEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaEmitidasType',
            'RegistroRespuestaConsultaRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaRecibidasType',
            'RegistroRespuestaConsultaFactInformadasClienteType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaFactInformadasClienteType',
            'RegistroRespuestaConsultaFactInformadasAgrupadasClienteType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaFactInformadasAgrupadasClienteType',
            'RegistroRespuestaConsultaVentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaVentaBienesConsignaType',
            'RegistroRespuestaConsultaFactInformadasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaFactInformadasProveedorType',
            'RegistroRespuestaConsultaFactInformadasAgrupadasProveedorType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaFactInformadasAgrupadasProveedorType',
            'RegistroRespuestaConsultaBienesType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaBienesType',
            'RegistroRespuestaConsultaDetOperIntracomunitariasType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaDetOperIntracomunitariasType',
            'RegistroRespuestaConsultaCobrosMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaCobrosMetalicoType',
            'RegistroRespuestaConsultaAgenciasViajesType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaAgenciasViajesType',
            'RegistroRespuestaConsultaOperacionesSegurosType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaOperacionesSegurosType',
            'RegistroRespuestaConsultaCobrosType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaCobrosType',
            'RegistroRespuestaConsultaInmueblesAdicionalesType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaInmueblesAdicionalesType',
            'RegistroRespuestaConsultaPagosType' => '\\clonixdev\\aemetsii\\StructType\\RegistroRespuestaConsultaPagosType',
            'RespuestaDetOperIntracomunitariaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaDetOperIntracomunitariaType',
            'RespuestaCobrosMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaCobrosMetalicoType',
            'RespuestaOperacionesSegurosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaOperacionesSegurosType',
            'RespuestaVentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaVentaBienesConsignaType',
            'RespuestaConsultaLRFacturasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRFacturasType',
            'RespuestaConsultaLRVentaBVType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaLRVentaBVType',
            'RespuestaConsultaFacturaCobrosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaFacturaCobrosType',
            'RespuestaConsultaInmueblesType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaInmueblesType',
            'RespuestaConsultaFacturaPagosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaConsultaFacturaPagosType',
            'FacturaRespuestaType' => '\\clonixdev\\aemetsii\\StructType\\FacturaRespuestaType',
            'FacturaRespuestaExpedidaType' => '\\clonixdev\\aemetsii\\StructType\\FacturaRespuestaExpedidaType',
            'FacturaRespuestaRecibidaType' => '\\clonixdev\\aemetsii\\StructType\\FacturaRespuestaRecibidaType',
            'FacturaRespuestaInformadaClienteType' => '\\clonixdev\\aemetsii\\StructType\\FacturaRespuestaInformadaClienteType',
            'FacturaRespuestaInformadaProveedorType' => '\\clonixdev\\aemetsii\\StructType\\FacturaRespuestaInformadaProveedorType',
            'RespuestaComunAltaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaComunAltaType',
            'RespuestaLRFEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRFEmitidasType',
            'RespuestaLRFRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRFRecibidasType',
            'RespuestaLRBajaFRecibidasPagosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBajaFRecibidasPagosType',
            'RespuestaLRBienesInversionType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBienesInversionType',
            'RespuestaLROComunitariasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLROComunitariasType',
            'RespuestaLRIMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRIMetalicoType',
            'RespuestaLRAgenciasViajesType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRAgenciasViajesType',
            'RespuestaLROperacionesSegurosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLROperacionesSegurosType',
            'RespuestaLRVentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRVentaBienesConsignaType',
            'RespuestaComunBajaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaComunBajaType',
            'RespuestaCobrosPagosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaCobrosPagosType',
            'RespuestaInmueblesType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaInmueblesType',
            'RespuestaLRBajaFEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBajaFEmitidasType',
            'RespuestaLRBajaFRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBajaFRecibidasType',
            'RespuestaLRBajaBienesInversionType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBajaBienesInversionType',
            'RespuestaLRBajaOComunitariasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBajaOComunitariasType',
            'RespuestaLRBajaVentaBienesConsignaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBajaVentaBienesConsignaType',
            'RespuestaLRBajaIMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBajaIMetalicoType',
            'RespuestaLRBajaAgenciasViajesType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBajaAgenciasViajesType',
            'RespuestaLRBajaOperacionesSegurosType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRBajaOperacionesSegurosType',
            'RespuestaLRCobrosEmitidasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRCobrosEmitidasType',
            'RespuestaLRInmueblesType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRInmueblesType',
            'RespuestaLRPagosRecibidasType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaLRPagosRecibidasType',
            'RespuestaExpedidaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaExpedidaType',
            'RespuestaExpedidaBajaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaExpedidaBajaType',
            'RespuestaExpedidaCobroType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaExpedidaCobroType',
            'RespuestaExpedidaInmueblesType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaExpedidaInmueblesType',
            'RespuestaRecibidaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaRecibidaType',
            'RespuestaRecibidaBajaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaRecibidaBajaType',
            'RespuestaRecibidaPagoType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaRecibidaPagoType',
            'RespuestaBienType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaBienType',
            'RespuestaBienBajaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaBienBajaType',
            'RespuestaComunitariaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaComunitariaType',
            'RespuestaComunitariaBajaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaComunitariaBajaType',
            'RespuestaVentaBienesConsignaBajaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaVentaBienesConsignaBajaType',
            'RespuestaMetalicoType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaMetalicoType',
            'RespuestaAgenciasViajesType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaAgenciasViajesType',
            'RespuestaMetalicoBajaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaMetalicoBajaType',
            'RespuestaAgenciasViajesBajaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaAgenciasViajesBajaType',
            'RespuestaOperacionesSegurosBajaType' => '\\clonixdev\\aemetsii\\StructType\\RespuestaOperacionesSegurosBajaType',
        );
    }
}
