<?php

namespace clonixdev\aemetsii\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Consulta ServiceType
 * @subpackage Services
 */
class Consulta extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named ConsultaLRFacturasRecibidas
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \clonixdev\aemetsii\StructType\LRConsultaRecibidasType $consultaLRFacturasRecibidas
     * @return \clonixdev\aemetsii\StructType\RespuestaConsultaLRFacturasRecibidasType|bool
     */
    public function ConsultaLRFacturasRecibidas(\clonixdev\aemetsii\StructType\LRConsultaRecibidasType $consultaLRFacturasRecibidas)
    {
        try {
            $this->setResult($this->getSoapClient()->ConsultaLRFacturasRecibidas($consultaLRFacturasRecibidas));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ConsultaLRFactInformadasProveedor
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \clonixdev\aemetsii\StructType\ConsultaLRFactInformadasProveedorType $consultaLRFactInformadasProveedor
     * @return \clonixdev\aemetsii\StructType\RespuestaConsultaLRFactInformadasProveedorType|bool
     */
    public function ConsultaLRFactInformadasProveedor(\clonixdev\aemetsii\StructType\ConsultaLRFactInformadasProveedorType $consultaLRFactInformadasProveedor)
    {
        try {
            $this->setResult($this->getSoapClient()->ConsultaLRFactInformadasProveedor($consultaLRFactInformadasProveedor));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * ConsultaLRFactInformadasAgrupadasProveedor
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \clonixdev\aemetsii\StructType\ConsultaLRFactInformadasAgrupadasProveedorType $consultaLRFactInformadasAgrupadasProveedor
     * @return \clonixdev\aemetsii\StructType\RespuestaConsultaLRFactInformadasAgrupadasProveedorType|bool
     */
    public function ConsultaLRFactInformadasAgrupadasProveedor(\clonixdev\aemetsii\StructType\ConsultaLRFactInformadasAgrupadasProveedorType $consultaLRFactInformadasAgrupadasProveedor)
    {
        try {
            $this->setResult($this->getSoapClient()->ConsultaLRFactInformadasAgrupadasProveedor($consultaLRFactInformadasAgrupadasProveedor));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \clonixdev\aemetsii\StructType\RespuestaConsultaLRFactInformadasAgrupadasProveedorType|\clonixdev\aemetsii\StructType\RespuestaConsultaLRFactInformadasProveedorType|\clonixdev\aemetsii\StructType\RespuestaConsultaLRFacturasRecibidasType
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
