<?php

namespace clonixdev\aemetsii\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LRFiltroOperacionesSegurosType StructType
 * @subpackage Structs
 */
class LRFiltroOperacionesSegurosType extends RegistroSii
{
    /**
     * The Contraparte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \clonixdev\aemetsii\StructType\ContraparteConsultaType
     */
    public $Contraparte;
    /**
     * The ClaveOperacion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ClaveOperacion;
    /**
     * The FechaPresentacion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \clonixdev\aemetsii\StructType\RangoFechaPresentacionType
     */
    public $FechaPresentacion;
    /**
     * The OperacionModificada
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $OperacionModificada;
    /**
     * The ClavePaginacion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \clonixdev\aemetsii\StructType\ClavePaginacion
     */
    public $ClavePaginacion;
    /**
     * Constructor method for LRFiltroOperacionesSegurosType
     * @uses LRFiltroOperacionesSegurosType::setContraparte()
     * @uses LRFiltroOperacionesSegurosType::setClaveOperacion()
     * @uses LRFiltroOperacionesSegurosType::setFechaPresentacion()
     * @uses LRFiltroOperacionesSegurosType::setOperacionModificada()
     * @uses LRFiltroOperacionesSegurosType::setClavePaginacion()
     * @param \clonixdev\aemetsii\StructType\ContraparteConsultaType $contraparte
     * @param string $claveOperacion
     * @param \clonixdev\aemetsii\StructType\RangoFechaPresentacionType $fechaPresentacion
     * @param string $operacionModificada
     * @param \clonixdev\aemetsii\StructType\ClavePaginacion $clavePaginacion
     */
    public function __construct(\clonixdev\aemetsii\StructType\ContraparteConsultaType $contraparte = null, $claveOperacion = null, \clonixdev\aemetsii\StructType\RangoFechaPresentacionType $fechaPresentacion = null, $operacionModificada = null, \clonixdev\aemetsii\StructType\ClavePaginacion $clavePaginacion = null)
    {
        $this
            ->setContraparte($contraparte)
            ->setClaveOperacion($claveOperacion)
            ->setFechaPresentacion($fechaPresentacion)
            ->setOperacionModificada($operacionModificada)
            ->setClavePaginacion($clavePaginacion);
    }
    /**
     * Get Contraparte value
     * @return \clonixdev\aemetsii\StructType\ContraparteConsultaType|null
     */
    public function getContraparte()
    {
        return $this->Contraparte;
    }
    /**
     * Set Contraparte value
     * @param \clonixdev\aemetsii\StructType\ContraparteConsultaType $contraparte
     * @return \clonixdev\aemetsii\StructType\LRFiltroOperacionesSegurosType
     */
    public function setContraparte(\clonixdev\aemetsii\StructType\ContraparteConsultaType $contraparte = null)
    {
        $this->Contraparte = $contraparte;
        return $this;
    }
    /**
     * Get ClaveOperacion value
     * @return string|null
     */
    public function getClaveOperacion()
    {
        return $this->ClaveOperacion;
    }
    /**
     * Set ClaveOperacion value
     * @uses \clonixdev\aemetsii\EnumType\ClaveOperacionType::valueIsValid()
     * @uses \clonixdev\aemetsii\EnumType\ClaveOperacionType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $claveOperacion
     * @return \clonixdev\aemetsii\StructType\LRFiltroOperacionesSegurosType
     */
    public function setClaveOperacion($claveOperacion = null)
    {
        // validation for constraint: enumeration
        if (!\clonixdev\aemetsii\EnumType\ClaveOperacionType::valueIsValid($claveOperacion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \clonixdev\aemetsii\EnumType\ClaveOperacionType', is_array($claveOperacion) ? implode(', ', $claveOperacion) : var_export($claveOperacion, true), implode(', ', \clonixdev\aemetsii\EnumType\ClaveOperacionType::getValidValues())), __LINE__);
        }
        $this->ClaveOperacion = $claveOperacion;
        return $this;
    }
    /**
     * Get FechaPresentacion value
     * @return \clonixdev\aemetsii\StructType\RangoFechaPresentacionType|null
     */
    public function getFechaPresentacion()
    {
        return $this->FechaPresentacion;
    }
    /**
     * Set FechaPresentacion value
     * @param \clonixdev\aemetsii\StructType\RangoFechaPresentacionType $fechaPresentacion
     * @return \clonixdev\aemetsii\StructType\LRFiltroOperacionesSegurosType
     */
    public function setFechaPresentacion(\clonixdev\aemetsii\StructType\RangoFechaPresentacionType $fechaPresentacion = null)
    {
        $this->FechaPresentacion = $fechaPresentacion;
        return $this;
    }
    /**
     * Get OperacionModificada value
     * @return string|null
     */
    public function getOperacionModificada()
    {
        return $this->OperacionModificada;
    }
    /**
     * Set OperacionModificada value
     * @uses \clonixdev\aemetsii\EnumType\FacturaModificadaType::valueIsValid()
     * @uses \clonixdev\aemetsii\EnumType\FacturaModificadaType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $operacionModificada
     * @return \clonixdev\aemetsii\StructType\LRFiltroOperacionesSegurosType
     */
    public function setOperacionModificada($operacionModificada = null)
    {
        // validation for constraint: enumeration
        if (!\clonixdev\aemetsii\EnumType\FacturaModificadaType::valueIsValid($operacionModificada)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \clonixdev\aemetsii\EnumType\FacturaModificadaType', is_array($operacionModificada) ? implode(', ', $operacionModificada) : var_export($operacionModificada, true), implode(', ', \clonixdev\aemetsii\EnumType\FacturaModificadaType::getValidValues())), __LINE__);
        }
        $this->OperacionModificada = $operacionModificada;
        return $this;
    }
    /**
     * Get ClavePaginacion value
     * @return \clonixdev\aemetsii\StructType\ClavePaginacion|null
     */
    public function getClavePaginacion()
    {
        return $this->ClavePaginacion;
    }
    /**
     * Set ClavePaginacion value
     * @param \clonixdev\aemetsii\StructType\ClavePaginacion $clavePaginacion
     * @return \clonixdev\aemetsii\StructType\LRFiltroOperacionesSegurosType
     */
    public function setClavePaginacion(\clonixdev\aemetsii\StructType\ClavePaginacion $clavePaginacion = null)
    {
        $this->ClavePaginacion = $clavePaginacion;
        return $this;
    }
}
