<?php

namespace clonixdev\aemetsii\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TitularPeriodoType StructType
 * @subpackage Structs
 */
class TitularPeriodoType extends AbstractStructBase
{
    /**
     * The Cabecera
     * Meta information extracted from the WSDL
     * - documentation: Titular de los libros de registro que suministra la información
     * @var \clonixdev\aemetsii\StructType\ConsultaInformacion
     */
    public $Cabecera;
    /**
     * The PeriodoLiquidacion
     * @var \clonixdev\aemetsii\StructType\PeriodoLiquidacion
     */
    public $PeriodoLiquidacion;
    /**
     * The IndicadorPaginacion
     * @var string
     */
    public $IndicadorPaginacion;
    /**
     * The ResultadoConsulta
     * @var string
     */
    public $ResultadoConsulta;
    /**
     * Constructor method for TitularPeriodoType
     * @uses TitularPeriodoType::setCabecera()
     * @uses TitularPeriodoType::setPeriodoLiquidacion()
     * @uses TitularPeriodoType::setIndicadorPaginacion()
     * @uses TitularPeriodoType::setResultadoConsulta()
     * @param \clonixdev\aemetsii\StructType\ConsultaInformacion $cabecera
     * @param \clonixdev\aemetsii\StructType\PeriodoLiquidacion $periodoLiquidacion
     * @param string $indicadorPaginacion
     * @param string $resultadoConsulta
     */
    public function __construct(\clonixdev\aemetsii\StructType\ConsultaInformacion $cabecera = null, \clonixdev\aemetsii\StructType\PeriodoLiquidacion $periodoLiquidacion = null, $indicadorPaginacion = null, $resultadoConsulta = null)
    {
        $this
            ->setCabecera($cabecera)
            ->setPeriodoLiquidacion($periodoLiquidacion)
            ->setIndicadorPaginacion($indicadorPaginacion)
            ->setResultadoConsulta($resultadoConsulta);
    }
    /**
     * Get Cabecera value
     * @return \clonixdev\aemetsii\StructType\ConsultaInformacion|null
     */
    public function getCabecera()
    {
        return $this->Cabecera;
    }
    /**
     * Set Cabecera value
     * @param \clonixdev\aemetsii\StructType\ConsultaInformacion $cabecera
     * @return \clonixdev\aemetsii\StructType\TitularPeriodoType
     */
    public function setCabecera(\clonixdev\aemetsii\StructType\ConsultaInformacion $cabecera = null)
    {
        $this->Cabecera = $cabecera;
        return $this;
    }
    /**
     * Get PeriodoLiquidacion value
     * @return \clonixdev\aemetsii\StructType\PeriodoLiquidacion|null
     */
    public function getPeriodoLiquidacion()
    {
        return $this->PeriodoLiquidacion;
    }
    /**
     * Set PeriodoLiquidacion value
     * @param \clonixdev\aemetsii\StructType\PeriodoLiquidacion $periodoLiquidacion
     * @return \clonixdev\aemetsii\StructType\TitularPeriodoType
     */
    public function setPeriodoLiquidacion(\clonixdev\aemetsii\StructType\PeriodoLiquidacion $periodoLiquidacion = null)
    {
        $this->PeriodoLiquidacion = $periodoLiquidacion;
        return $this;
    }
    /**
     * Get IndicadorPaginacion value
     * @return string|null
     */
    public function getIndicadorPaginacion()
    {
        return $this->IndicadorPaginacion;
    }
    /**
     * Set IndicadorPaginacion value
     * @uses \clonixdev\aemetsii\EnumType\IndicadorPaginacionType::valueIsValid()
     * @uses \clonixdev\aemetsii\EnumType\IndicadorPaginacionType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $indicadorPaginacion
     * @return \clonixdev\aemetsii\StructType\TitularPeriodoType
     */
    public function setIndicadorPaginacion($indicadorPaginacion = null)
    {
        // validation for constraint: enumeration
        if (!\clonixdev\aemetsii\EnumType\IndicadorPaginacionType::valueIsValid($indicadorPaginacion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \clonixdev\aemetsii\EnumType\IndicadorPaginacionType', is_array($indicadorPaginacion) ? implode(', ', $indicadorPaginacion) : var_export($indicadorPaginacion, true), implode(', ', \clonixdev\aemetsii\EnumType\IndicadorPaginacionType::getValidValues())), __LINE__);
        }
        $this->IndicadorPaginacion = $indicadorPaginacion;
        return $this;
    }
    /**
     * Get ResultadoConsulta value
     * @return string|null
     */
    public function getResultadoConsulta()
    {
        return $this->ResultadoConsulta;
    }
    /**
     * Set ResultadoConsulta value
     * @uses \clonixdev\aemetsii\EnumType\ResultadoConsultaType::valueIsValid()
     * @uses \clonixdev\aemetsii\EnumType\ResultadoConsultaType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $resultadoConsulta
     * @return \clonixdev\aemetsii\StructType\TitularPeriodoType
     */
    public function setResultadoConsulta($resultadoConsulta = null)
    {
        // validation for constraint: enumeration
        if (!\clonixdev\aemetsii\EnumType\ResultadoConsultaType::valueIsValid($resultadoConsulta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \clonixdev\aemetsii\EnumType\ResultadoConsultaType', is_array($resultadoConsulta) ? implode(', ', $resultadoConsulta) : var_export($resultadoConsulta, true), implode(', ', \clonixdev\aemetsii\EnumType\ResultadoConsultaType::getValidValues())), __LINE__);
        }
        $this->ResultadoConsulta = $resultadoConsulta;
        return $this;
    }
}
